#uses "fwUnitTestComponentAsserts.ctl"

#uses "test/unFrontEnd/unFrontEndTest_helper.ctl"


#uses "unConfigGenericFunctions.ctl"

const string DEVICES_DRIVER_NUMBER = "3";


//-------------------------------------------------------
void test_unImportDevice_updatePlcModel_setupSuite() {
	unImportTestDevice_helper_startDriver(DEVICES_DRIVER_NUMBER);
	fwDevice_initialize(); //needed by unImportDevice_checkFile()... dont ask me why
}

//--------------------------------------------------------
void test_unImportDevice_updatePlcModel_teardownSuite() {
	dyn_string dsDp=dpNames("*PLCTEST01*");
	dynAppend( dsDp, dpNames("*PLCENICE02*"));
	dynAppend( dsDp, dpNames("_Mod_Plc_3"));
	for(int i=1; i<=dynlen(dsDp);i++)	dpDelete(dsDp[i]);
}


//-------------------------------------------------------
void test_unImportDevice_updateSiemensModel() {
	_test_unImportDevice_importAndThenCheck("S7_PLC","test_unFrontEnd/wincc_oa_db_file_Siemens-PLCTEST01_S7-300.txt",
														"test_unFrontEnd/wincc_oa_db_file_Siemens-PLCTEST01_S7-700.txt");
}

//-------------------------------------------------------
void test_unImportDevice_updateSchneiderModel() {
	_test_unImportDevice_importAndThenCheck("_UnPlc", "test_unFrontEnd/wincc_oa_db_file_Schneider_PLCENICE02_M580.txt",
														"test_unFrontEnd/wincc_oa_db_file_Schneider_PLCENICE02_PREMIUM.txt");
}


private void _test_unImportDevice_importAndThenCheck( string sFrontEndType, string sImportFile1, string sImportFile2){
  bool importOk = false;
  bool checkBeforeImporting = false;
  string sLogContent;
 
  //-------First import the frontend a with first model
  //import
  importOk = unImportTestDevice_helper_importDevices(sImportFile1, DEVICES_DRIVER_NUMBER, sLogContent);

  //check that importation is ok 
  assertEqual( true, importOk, "An error occured while importing " + sImportFile1 + "\n"+sLogContent);
  unImportTestDevice_helper_checkImportSuccessful(sImportFile1, sLogContent);

  //------Second, check that that the second import with a different model can be done
  // for  ENS-22040, the issue was at the check level not the import level for Schneider PLC
  checkBeforeImporting = unImportTestDevice_helper_checkDevices( sImportFile2, sFrontEndType, DEVICES_DRIVER_NUMBER, sLogContent); 
  bool bIsWarningPresent = strpos(sLogContent, "WARNING") >= 0;
  bool bIsErrorPresent = strpos(sLogContent, "ERROR") >= 0;
  assertTrue( checkBeforeImporting, "Unable to check import file", sImportFile2);
  assertEqual( false, bIsWarningPresent, "There was a warning when importing" + sImportFile2 + "\n"+sLogContent);
  assertEqual( false, bIsErrorPresent, "There was an error when importing " + sImportFile2 + "\n"+sLogContent);
}


